<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>AdjustableTransform - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="AdjustableTransform.html">AdjustableTransform</a><ul class='members'><li data-type='member' style='display: none;'><a href="AdjustableTransform.html#costs">costs</a></li><li data-type='member' style='display: none;'><a href="AdjustableTransform.html#upsilons">upsilons</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#isConnected">isConnected</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#isDependent">isDependent</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#df">df</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#df">df</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#getB">getB</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#getBValues">getBValues</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#adjust">adjust</a></li><li data-type='method' style='display: none;'><a href="AdjustableTransform.html#adjustWeights">adjustWeights</a></li></ul></li><li><a href="BufferedOutputWeightAdjustment.html">BufferedOutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="BufferedOutputWeightAdjustment.html#setValues">setValues</a></li><li data-type='method' style='display: none;'><a href="BufferedOutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="EntropyWeightAdjustment.html">EntropyWeightAdjustment</a><ul class='members'></ul></li><li><a href="LpOutputWeightAdjustment.html">LpOutputWeightAdjustment</a><ul class='members'></ul></li><li><a href="NLNTransform.html">NLNTransform</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NLNTransform.html#createConnection">createConnection</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#getW">getW</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#h">h</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#dh">dh</a></li><li data-type='method' style='display: none;'><a href="NLNTransform.html#g">g</a></li></ul></li><li><a href="OutputWeightAdjustment.html">OutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="OutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="QuadLin.html">QuadLin</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QuadLin.html#setWo">setWo</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#f">f</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#df">df</a></li><li data-type='method' style='display: none;'><a href="QuadLin.html#dw">dw</a></li></ul></li><li><a href="QuadLinOutputWeightAdjustment.html">QuadLinOutputWeightAdjustment</a><ul class='members'></ul></li><li><a href="QuadLinWeightRegularization.html">QuadLinWeightRegularization</a><ul class='members'></ul></li><li><a href="RandomOutputWeightAdjustment.html">RandomOutputWeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="RandomOutputWeightAdjustment.html#o">o</a></li></ul></li><li><a href="RandomTransformInput.html">RandomTransformInput</a><ul class='members'></ul></li><li><a href="ReservoirTransform.html">ReservoirTransform</a><ul class='members'></ul></li><li><a href="Sigmoid.html">Sigmoid</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Sigmoid.html#f">f</a></li><li data-type='method' style='display: none;'><a href="Sigmoid.html#df">df</a></li></ul></li><li><a href="Transform.html">Transform</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Transform.html#init">init</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getParameter">getParameter</a></li><li data-type='method' style='display: none;'><a href="Transform.html#asString">asString</a></li><li data-type='method' style='display: none;'><a href="Transform.html#f">f</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getF">getF</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getFValues">getFValues</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getW">getW</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getWeights">getWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setW">setW</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#setWeights">setWeights</a></li><li data-type='method' style='display: none;'><a href="Transform.html#getWeightsDistance">getWeightsDistance</a></li></ul></li><li><a href="TransformBuffer.html">TransformBuffer</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformBuffer.html#add">add</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#load">load</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#get">get</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getUnitCount">getUnitCount</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getTimeCount">getTimeCount</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getUnitSlice">getUnitSlice</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getTimeSlice">getTimeSlice</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getSamples">getSamples</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#getChannels">getChannels</a></li><li data-type='method' style='display: none;'><a href="TransformBuffer.html#asString">asString</a></li></ul></li><li><a href="TransformInput.html">TransformInput</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformInput.html#setValues">setValues</a></li><li data-type='method' style='display: none;'><a href="TransformInput.html#i">i</a></li></ul></li><li><a href="TransformObserver.html">TransformObserver</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="TransformObserver.html#add">add</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getStat">getStat</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getStats">getStats</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#plotData">plotData</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#simulate">simulate</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#getSpatialDivergence">getSpatialDivergence</a></li><li data-type='method' style='display: none;'><a href="TransformObserver.html#asString">asString</a></li></ul></li><li><a href="WeightAdjustment.html">WeightAdjustment</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WeightAdjustment.html#c">c</a></li><li data-type='method' style='display: none;'><a href="WeightAdjustment.html#dc">dc</a></li></ul></li><li><a href="WeightRegularization.html">WeightRegularization</a><ul class='members'><li data-type='member' style='display: none;'><a href="WeightRegularization.html#.upsilon">upsilon</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="WeightRegularization.html#l">l</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">AdjustableTransform</h1>
    

    




<section>

<header>
    
        <h2>
        
            AdjustableTransform
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="AdjustableTransform"><span class="type-signature type-signature-abstract">(abstract) </span>new AdjustableTransform<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Defines a dynamical system tuned by backward learning.</p>
<center><iframe style='width: 100%; height: calc(55vw);' src='adjustabletransform.pdf'></iframe></center><a href='adjustabletransform.pdf' target='_blank'>&nbsp;&nbsp;(open in new tab)</a><br/>
<ul>
<li>The <code>df(·)</code> methods have to be implemented.</li>
<li>The backward state values are calculated, updated if needed and buffered for <code>0 &lt;= n &lt; N</code> and <code>0 &lt;= t &lt; T</code>.</li>
</ul>
<h4>Extends: <a href='./Transform.html'>Transform</a>, with all public methods available.</h4>
<h4>Extends: <a href='./WeightAdjustment.html'>WeightAdjustment</a>, with all public methods available.</h4>
<h4>Extends: <a href='./WeightRegularization.html'>WeightRegularization</a>, with all public methods available.</h4></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>Object parameter, including parent class parameters:</p>
<ul>
<li><code>K0</code> : Specifies the weights to be adjusted.
<ul>
<li><code>0 &lt; K0 &lt;= K</code> allows to estimate only the first <code>K0</code> weights of index <code>0 &lt;= k &lt; K0</code>, while the <code>K-K0</code> weights remains fixed.</li>
<li><code>0</code> corresponds to no weith adjustment.</li>
<li>otherwise all weights are adjusted.</li>
</ul>
</li>
<li><code>R</code> : Maximal recurrence of time-window the system equation (used to bound backward tuning calculations).
<ul>
<li><code>R = 1</code> means that the current value depends only on the previous values.</li>
<li><code>R = 0</code> means that the current value depends on all previous values (default).</li>
</ul>
</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Members</h3>

        
            













        
            
<h4 class="name" id="costs"><span class="type-signature"></span>costs<span class="type-signature"> :Array</span></h4>





<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Trace of the costs decrease when calling adjust.</p>
<ul>
<li>Before the 1st step and after each adjustment done calling <a href="#adjust">adjust()</a>, the cost evaluation is pushed.</li>
<li>Only decreasing costs (thus updating the weights) are taken into account.</li>
<li>This <code>std::vector&lt;double&gt;</code> buffer can be edited, cleared, and so on.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Trace of the costs decrease when calling adjust.</p>
<ul>
<li>Before the 1st step and after each adjustment done calling <a href="#adjust">adjust()</a>, the cost evaluation is pushed.</li>
<li>Only decreasing costs (thus updating the weights) are taken into account.</li>
<li>This <code>std::vector&lt;double&gt;</code> buffer can be edited, cleared, and so on.</li>
</ul>
</div>



    <h5 class="h5-types">Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Array</span>



        </li>
    </ul>






        
            
<h4 class="name" id="upsilons"><span class="type-signature"></span>upsilons<span class="type-signature"> :Array</span></h4>





<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Trace of the upsilon adjustment when calling adjust.</p>
<ul>
<li>When calling <a href="#adjust">adjust()</a>, the upsilon value is pushed before each use.</li>
<li>This <code>std::vector&lt;double&gt;</code> buffer can be edited, cleared, and so on.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Trace of the upsilon adjustment when calling adjust.</p>
<ul>
<li>When calling <a href="#adjust">adjust()</a>, the upsilon value is pushed before each use.</li>
<li>This <code>std::vector&lt;double&gt;</code> buffer can be edited, cleared, and so on.</li>
</ul>
</div>



    <h5 class="h5-types">Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Array</span>



        </li>
    </ul>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="isConnected"><span class="type-signature type-signature-abstract">(abstract) </span>isConnected<span class="signature">(n, m, r)</span><span class="type-signature"> &rarr; {bool}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Checks if the spatio-temporal values are connected.</p>
<ul>
<li>The default implementation considers a fully connected network, thus returns true.</li>
<li>This is to overleaded for sparse connected networks, in order to increase performances.</li>
<li>This method is called at the beggining of the use of this object only, thus no need to optimize it.</li>
<li>The network connectivity is assumed to be stationnary, if not, it must be implemented via zero value weight.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Efferent unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>m</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Afferent uint index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>r</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Current time difference <code>t - s &gt;= 0</code>.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>True if the spatio-temporal value of index <code>(n, t)</code> depends on the one of index <code>(m, s = t - r)</code>.</p>
<ul>
<li>To preserve causality if <code>t == s</code> we must have <code>n &gt; m</code>.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">bool</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="isDependent"><span class="type-signature type-signature-abstract">(abstract) </span>isDependent<span class="signature">(n, k)</span><span class="type-signature"> &rarr; {bool}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Checks if a unit value depends on a weight value.</p>
<ul>
<li>The default implementation considers the weight influence for the whole network.</li>
<li>This is to overleaded to state local weight influence, in order to increase performances.</li>
<li>This method is called at the beggining of the use of this object only, thus no need to optimize it.</li>
<li>The network weight dependency is assumed to be stationnary, if not, it must be implemented via zero value weight.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Efferent unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>k</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The weight index.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>True if the value of index <code>n</code> depends on the weight of index <code>k</code>.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">bool</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="df"><span class="type-signature type-signature-abstract">(abstract) </span>df<span class="signature">(m, s, n, t)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the dynamic equation state derivative.</p>
<ul>
<li>Calculates <code>d_{ms} f_n(t, …)</code>.</li>
<li>By contract, <code>df(m, s, n, t)</code> is called only if
<ul>
<li><code>n &lt; N</code>, <code>t &lt; T</code>, <code>m &lt; N</code>, <code>s &lt; T</code>, <code>t - s &lt;= R</code>,</li>
<li>units of indexes <code>(n, t)</code> and <code>(m, s)</code> are connected,
<ul>
<li>thus no need to re-check these conditions.</li>
</ul>
</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>m</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Afferent unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>s</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Time derivative.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Efferent unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>t</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Current time.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="df"><span class="type-signature type-signature-abstract">(abstract) </span>df<span class="signature">(k, n, t)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the dynamic equation parameter derivative.</p>
<ul>
<li>Calculates <code>d_{W_k} f_n(t, …)</code>.</li>
<li>By contract, <code>df(k, n, t)</code> is called only if
<ul>
<li><code>k &lt; K</code>, <code>n &lt; N</code>, <code>t &lt; T</code>,</li>
<li>unit of index <code>n</code> depends on weight of index <code>k</code>,
<ul>
<li>thus no need to re-check these conditions.</li>
</ul>
</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>k</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Parameter index derivative.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>t</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Current time.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding value.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getB"><span class="type-signature"></span>getB<span class="signature">(n, t)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the current backward state value.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>n</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Unit index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>t</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Current time.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding value, or <code>NAN</code> if out of bound.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getBValues"><span class="type-signature"></span>getBValues<span class="signature">()</span><span class="type-signature"> &rarr; {Array}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the current backward values.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A 1D <code>double[N * T]</code> array with <code>x_n(t) = values[n + N * t]</code>.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="adjust"><span class="type-signature"></span>adjust<span class="signature">(count<span class="signature-attributes">opt</span>, epsilon<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Performs one or more step of parameter adjustment.</p>
<ul>
<li>The network weights are changed in order to correspond to the minimal cost.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>count</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>1</code>
                
                </td>
            

            <td class="description last"><p>The number of adjustment steps. Set to <code>-1</code> for an almost unbounded number of steps.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>epsilon</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>The minimal weight adjustment gain <code>upsilon</code>. Set to <code>0</code> not skip the test.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The obtained cost after the adjustment·s.</p>
<ul>
<li>Each obtained cost is also registered in the <a href="#costs">costs</a> vector.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="adjustWeights"><span class="type-signature"></span>adjustWeights<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Performs the adjustment of the weights, given forward and backward values.</p>
<ul>
<li>This method can be overwritten for specific networks to increase convergence.</li>
<li>This methods directly uses the class members variables.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>